function C = cov_mtx(X);

[M N] = size(X);
dnmax = 30;
dmmax = 30;
% Warning: it should be dnmax<<N, dmmax<<M

% Compute the correlation coefficient matrix
X0 = X(1+dnmax:N-dnmax,1+dmmax:M-dmmax);
x0 = X0(:);
m0 = mean(x0);
s0 = (x0-m0)'*(x0-m0);
for dn=-dnmax:dnmax,
   for dm=-dmmax:dmmax,
      X1 = X(1+dnmax+dn:N-dnmax+dn,1+dmmax+dm:M-dmmax+dm);
      x1 = X1(:);
      m1 = mean(x1);
      rho = (x0-m0)'*(x1-m1);
      C(dnmax+1+dn,dmmax+1+dm) = rho/length(x0);
   end;
end;
